package com.astraia.dicom.views.swing;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;



import akka.actor.ActorContext;

public class MainFrame {

	//Not GUI stuff
	private ActorContext viewActorCtx=null;
	
	private JFrame frmDicomDiagnostics;
	private JTextField pacsIpText;
	private JTextField pacsPortText;
	private JTextField pacsAetText;
	private JTextField localPortText;
	private JTextField localAetText;
	private JTextField cFindPatientIDText;
	private JTextField textField;
	private JTextField textField_1;
	private JTextField textField_2;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainFrame window = new MainFrame(null);
					window.frmDicomDiagnostics.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public MainFrame(ActorContext viewActor) {
		this.viewActorCtx=viewActor;
		initialize();
	}

	/*
	 * This gets called the first time the windows is loaded, so it can request initial values
	 * to the controller
	 */
	private void initRequests() {
		if(this.viewActorCtx!=null) {
			//the application context
			//viewActorCtx.parent().tell(GetAppContext$.MODULE$, viewActorCtx.self());
		}
	}
	
	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmDicomDiagnostics = new JFrame();
		frmDicomDiagnostics.setTitle("Dicom Diagnostics");
		frmDicomDiagnostics.addWindowListener(new WindowAdapter() {
			@Override
			public void windowOpened(WindowEvent e) {
				//here we request to the controller all the info
				initRequests();
			}
		});
		frmDicomDiagnostics.setBounds(100, 100, 978, 762);
		frmDicomDiagnostics.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmDicomDiagnostics.getContentPane().setLayout(new BorderLayout(0, 0));
		
		JPanel appContextPanel = new JPanel();
		frmDicomDiagnostics.getContentPane().add(appContextPanel, BorderLayout.EAST);
		appContextPanel.setLayout(new BoxLayout(appContextPanel, BoxLayout.PAGE_AXIS));
		
		JLabel lblAppcontext = new JLabel("App Context");
		lblAppcontext.setAlignmentX(Component.CENTER_ALIGNMENT);
		lblAppcontext.setAlignmentY(Component.TOP_ALIGNMENT);
		appContextPanel.add(lblAppcontext);
		
		JScrollPane scrollPane = new JScrollPane();
		appContextPanel.add(scrollPane);
		
		JTextArea textArea = new JTextArea();
		textArea.setColumns(30);
		scrollPane.setViewportView(textArea);
		
		JPanel headerInfoPanel = new JPanel();
		frmDicomDiagnostics.getContentPane().add(headerInfoPanel, BorderLayout.NORTH);
		GridBagLayout gbl_headerInfoPanel = new GridBagLayout();
		gbl_headerInfoPanel.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
		gbl_headerInfoPanel.rowWeights = new double[]{0.0, 1.0, 0.0, 0.0, 0.0};
		headerInfoPanel.setLayout(gbl_headerInfoPanel);
		
		Component rigidArea_2 = Box.createRigidArea(new Dimension(20, 10));
		GridBagConstraints gbc_rigidArea_2 = new GridBagConstraints();
		gbc_rigidArea_2.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea_2.gridx = 0;
		gbc_rigidArea_2.gridy = 2;
		headerInfoPanel.add(rigidArea_2, gbc_rigidArea_2);
		
		Component rigidArea_3 = Box.createRigidArea(new Dimension(20, 20));
		GridBagConstraints gbc_rigidArea_3 = new GridBagConstraints();
		gbc_rigidArea_3.insets = new Insets(0, 0, 0, 5);
		gbc_rigidArea_3.gridx = 0;
		gbc_rigidArea_3.gridy = 4;
		headerInfoPanel.add(rigidArea_3, gbc_rigidArea_3);
		
		JLabel localIpLabel = new JLabel("local ip: 192.168.x.x");
		GridBagConstraints gbc_localIpLabel = new GridBagConstraints();
		gbc_localIpLabel.gridwidth = 2;
		gbc_localIpLabel.insets = new Insets(0, 0, 0, 5);
		gbc_localIpLabel.gridx = 1;
		gbc_localIpLabel.gridy = 3;
		headerInfoPanel.add(localIpLabel, gbc_localIpLabel);
		
		Component rigidArea = Box.createRigidArea(new Dimension(20, 20));
		GridBagConstraints gbc_rigidArea = new GridBagConstraints();
		gbc_rigidArea.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea.gridx = 3;
		gbc_rigidArea.gridy = 1;
		headerInfoPanel.add(rigidArea, gbc_rigidArea);
		
		JLabel lblPacsPort = new JLabel("Pacs port");
		GridBagConstraints gbc_lblPacsPort = new GridBagConstraints();
		gbc_lblPacsPort.insets = new Insets(0, 0, 5, 5);
		gbc_lblPacsPort.anchor = GridBagConstraints.EAST;
		gbc_lblPacsPort.gridx = 4;
		gbc_lblPacsPort.gridy = 1;
		headerInfoPanel.add(lblPacsPort, gbc_lblPacsPort);
		
		pacsPortText = new JTextField();
		GridBagConstraints gbc_pacsPortText = new GridBagConstraints();
		gbc_pacsPortText.anchor = GridBagConstraints.WEST;
		gbc_pacsPortText.insets = new Insets(0, 0, 5, 5);
		gbc_pacsPortText.gridx = 5;
		gbc_pacsPortText.gridy = 1;
		headerInfoPanel.add(pacsPortText, gbc_pacsPortText);
		pacsPortText.setColumns(5);
		
		Component rigidArea_1 = Box.createRigidArea(new Dimension(20, 20));
		GridBagConstraints gbc_rigidArea_1 = new GridBagConstraints();
		gbc_rigidArea_1.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea_1.gridx = 6;
		gbc_rigidArea_1.gridy = 1;
		headerInfoPanel.add(rigidArea_1, gbc_rigidArea_1);
		
		JLabel lblNewLabel = new JLabel("Pacs AET");
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.anchor = GridBagConstraints.EAST;
		gbc_lblNewLabel.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel.gridx = 7;
		gbc_lblNewLabel.gridy = 1;
		headerInfoPanel.add(lblNewLabel, gbc_lblNewLabel);
		
		pacsAetText = new JTextField();
		GridBagConstraints gbc_pacsAetText = new GridBagConstraints();
		gbc_pacsAetText.insets = new Insets(0, 0, 5, 0);
		gbc_pacsAetText.anchor = GridBagConstraints.WEST;
		gbc_pacsAetText.gridx = 8;
		gbc_pacsAetText.gridy = 1;
		headerInfoPanel.add(pacsAetText, gbc_pacsAetText);
		pacsAetText.setColumns(10);
		
		JLabel lblD = new JLabel("Pacs IP");
		GridBagConstraints gbc_lblD = new GridBagConstraints();
		gbc_lblD.insets = new Insets(0, 0, 5, 5);
		gbc_lblD.anchor = GridBagConstraints.EAST;
		gbc_lblD.gridx = 1;
		gbc_lblD.gridy = 1;
		headerInfoPanel.add(lblD, gbc_lblD);
		
		pacsIpText = new JTextField();
		GridBagConstraints gbc_pacsIpText = new GridBagConstraints();
		gbc_pacsIpText.insets = new Insets(0, 0, 5, 5);
		gbc_pacsIpText.anchor = GridBagConstraints.LINE_START;
		gbc_pacsIpText.gridx = 2;
		gbc_pacsIpText.gridy = 1;
		headerInfoPanel.add(pacsIpText, gbc_pacsIpText);
		pacsIpText.setColumns(10);
		
		JLabel lblLocalPort = new JLabel("Local port");
		GridBagConstraints gbc_lblLocalPort = new GridBagConstraints();
		gbc_lblLocalPort.anchor = GridBagConstraints.EAST;
		gbc_lblLocalPort.insets = new Insets(0, 0, 0, 5);
		gbc_lblLocalPort.gridx = 4;
		gbc_lblLocalPort.gridy = 3;
		headerInfoPanel.add(lblLocalPort, gbc_lblLocalPort);
		
		localPortText = new JTextField();
		localPortText.setColumns(5);
		GridBagConstraints gbc_localPortText = new GridBagConstraints();
		gbc_localPortText.anchor = GridBagConstraints.WEST;
		gbc_localPortText.insets = new Insets(0, 0, 0, 5);
		gbc_localPortText.gridx = 5;
		gbc_localPortText.gridy = 3;
		headerInfoPanel.add(localPortText, gbc_localPortText);
		
		JLabel lblLocalAet = new JLabel("Local AET");
		GridBagConstraints gbc_lblLocalAet = new GridBagConstraints();
		gbc_lblLocalAet.anchor = GridBagConstraints.EAST;
		gbc_lblLocalAet.insets = new Insets(0, 0, 0, 5);
		gbc_lblLocalAet.gridx = 7;
		gbc_lblLocalAet.gridy = 3;
		headerInfoPanel.add(lblLocalAet, gbc_lblLocalAet);
		
		localAetText = new JTextField();
		localAetText.setColumns(10);
		GridBagConstraints gbc_localAetText = new GridBagConstraints();
		gbc_localAetText.anchor = GridBagConstraints.WEST;
		gbc_localAetText.gridx = 8;
		gbc_localAetText.gridy = 3;
		headerInfoPanel.add(localAetText, gbc_localAetText);
		
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		frmDicomDiagnostics.getContentPane().add(tabbedPane, BorderLayout.CENTER);
		
		JPanel cFindPanel = new JPanel();
		tabbedPane.addTab("C-FIND", null, cFindPanel, null);
		cFindPanel.setLayout(new BorderLayout(0, 0));
		
		Component verticalStrut = Box.createVerticalStrut(20);
		cFindPanel.add(verticalStrut, BorderLayout.NORTH);
		
		Component verticalStrut_1 = Box.createVerticalStrut(20);
		cFindPanel.add(verticalStrut_1, BorderLayout.WEST);
		
		JPanel general = new JPanel();
		cFindPanel.add(general, BorderLayout.CENTER);
		general.setLayout(new BoxLayout(general, BoxLayout.Y_AXIS));
		
		JPanel selectInfo = new JPanel();
		selectInfo.setBorder(new TitledBorder(null, "Select Query", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		general.add(selectInfo);
		GridBagLayout gbl_selectInfo = new GridBagLayout();
		gbl_selectInfo.columnWidths = new int[]{0, 0, 0, 0};
		gbl_selectInfo.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_selectInfo.columnWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_selectInfo.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		selectInfo.setLayout(gbl_selectInfo);
		
		Component rigidArea_7 = Box.createRigidArea(new Dimension(20, 20));
		GridBagConstraints gbc_rigidArea_7 = new GridBagConstraints();
		gbc_rigidArea_7.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea_7.gridx = 0;
		gbc_rigidArea_7.gridy = 0;
		selectInfo.add(rigidArea_7, gbc_rigidArea_7);
		
		JButton btnNewButton = new JButton("Fill from Database");
		GridBagConstraints gbc_btnNewButton = new GridBagConstraints();
		gbc_btnNewButton.gridwidth = 2;
		gbc_btnNewButton.insets = new Insets(0, 0, 5, 0);
		gbc_btnNewButton.gridx = 1;
		gbc_btnNewButton.gridy = 1;
		selectInfo.add(btnNewButton, gbc_btnNewButton);
		
		Component rigidArea_4 = Box.createRigidArea(new Dimension(20, 10));
		GridBagConstraints gbc_rigidArea_4 = new GridBagConstraints();
		gbc_rigidArea_4.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea_4.gridx = 1;
		gbc_rigidArea_4.gridy = 2;
		selectInfo.add(rigidArea_4, gbc_rigidArea_4);
		
		JSeparator separator = new JSeparator();
		GridBagConstraints gbc_separator = new GridBagConstraints();
		gbc_separator.fill = GridBagConstraints.BOTH;
		gbc_separator.gridwidth = 2;
		gbc_separator.insets = new Insets(0, 0, 5, 0);
		gbc_separator.gridx = 1;
		gbc_separator.gridy = 3;
		selectInfo.add(separator, gbc_separator);
		
		Component rigidArea_6 = Box.createRigidArea(new Dimension(20, 10));
		GridBagConstraints gbc_rigidArea_6 = new GridBagConstraints();
		gbc_rigidArea_6.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea_6.gridx = 1;
		gbc_rigidArea_6.gridy = 4;
		selectInfo.add(rigidArea_6, gbc_rigidArea_6);
		
		JLabel lblPatientId = new JLabel("Patient ID");
		GridBagConstraints gbc_lblPatientId = new GridBagConstraints();
		gbc_lblPatientId.insets = new Insets(0, 0, 5, 5);
		gbc_lblPatientId.anchor = GridBagConstraints.EAST;
		gbc_lblPatientId.gridx = 1;
		gbc_lblPatientId.gridy = 5;
		selectInfo.add(lblPatientId, gbc_lblPatientId);
		
		cFindPatientIDText = new JTextField();
		GridBagConstraints gbc_cFindPatientIDText = new GridBagConstraints();
		gbc_cFindPatientIDText.insets = new Insets(0, 0, 5, 0);
		gbc_cFindPatientIDText.anchor = GridBagConstraints.WEST;
		gbc_cFindPatientIDText.gridx = 2;
		gbc_cFindPatientIDText.gridy = 5;
		selectInfo.add(cFindPatientIDText, gbc_cFindPatientIDText);
		cFindPatientIDText.setColumns(10);
		
		JLabel lblStudyUid = new JLabel("Study UID");
		GridBagConstraints gbc_lblStudyUid = new GridBagConstraints();
		gbc_lblStudyUid.anchor = GridBagConstraints.EAST;
		gbc_lblStudyUid.insets = new Insets(0, 0, 5, 5);
		gbc_lblStudyUid.gridx = 1;
		gbc_lblStudyUid.gridy = 6;
		selectInfo.add(lblStudyUid, gbc_lblStudyUid);
		
		textField = new JTextField();
		GridBagConstraints gbc_textField = new GridBagConstraints();
		gbc_textField.insets = new Insets(0, 0, 5, 0);
		gbc_textField.anchor = GridBagConstraints.WEST;
		gbc_textField.gridx = 2;
		gbc_textField.gridy = 6;
		selectInfo.add(textField, gbc_textField);
		textField.setColumns(40);
		
		JLabel lblSeriesUid = new JLabel("Series UID");
		GridBagConstraints gbc_lblSeriesUid = new GridBagConstraints();
		gbc_lblSeriesUid.anchor = GridBagConstraints.EAST;
		gbc_lblSeriesUid.insets = new Insets(0, 0, 5, 5);
		gbc_lblSeriesUid.gridx = 1;
		gbc_lblSeriesUid.gridy = 7;
		selectInfo.add(lblSeriesUid, gbc_lblSeriesUid);
		
		textField_1 = new JTextField();
		textField_1.setColumns(40);
		GridBagConstraints gbc_textField_1 = new GridBagConstraints();
		gbc_textField_1.anchor = GridBagConstraints.WEST;
		gbc_textField_1.insets = new Insets(0, 0, 5, 0);
		gbc_textField_1.gridx = 2;
		gbc_textField_1.gridy = 7;
		selectInfo.add(textField_1, gbc_textField_1);
		
		JLabel lblImageUid = new JLabel("Image UID");
		GridBagConstraints gbc_lblImageUid = new GridBagConstraints();
		gbc_lblImageUid.anchor = GridBagConstraints.EAST;
		gbc_lblImageUid.insets = new Insets(0, 0, 5, 5);
		gbc_lblImageUid.gridx = 1;
		gbc_lblImageUid.gridy = 8;
		selectInfo.add(lblImageUid, gbc_lblImageUid);
		
		textField_2 = new JTextField();
		textField_2.setColumns(40);
		GridBagConstraints gbc_textField_2 = new GridBagConstraints();
		gbc_textField_2.insets = new Insets(0, 0, 5, 0);
		gbc_textField_2.anchor = GridBagConstraints.WEST;
		gbc_textField_2.gridx = 2;
		gbc_textField_2.gridy = 8;
		selectInfo.add(textField_2, gbc_textField_2);
		
		Component rigidArea_5 = Box.createRigidArea(new Dimension(20, 20));
		GridBagConstraints gbc_rigidArea_5 = new GridBagConstraints();
		gbc_rigidArea_5.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea_5.gridx = 1;
		gbc_rigidArea_5.gridy = 9;
		selectInfo.add(rigidArea_5, gbc_rigidArea_5);
		
		JButton btnQuery = new JButton("Query");
		GridBagConstraints gbc_btnQuery = new GridBagConstraints();
		gbc_btnQuery.gridwidth = 2;
		gbc_btnQuery.gridx = 1;
		gbc_btnQuery.gridy = 10;
		selectInfo.add(btnQuery, gbc_btnQuery);
		
		Component verticalStrut_2 = Box.createVerticalStrut(20);
		general.add(verticalStrut_2);
		
		JPanel results = new JPanel();
		results.setBorder(new TitledBorder(null, "Results", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		general.add(results);
		GridBagLayout gbl_results = new GridBagLayout();
		gbl_results.columnWidths = new int[]{0, 0, 0};
		gbl_results.rowHeights = new int[]{0, 0, 0, 0, 0};
		gbl_results.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_results.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		results.setLayout(gbl_results);
		
		Component rigidArea_8 = Box.createRigidArea(new Dimension(20, 20));
		GridBagConstraints gbc_rigidArea_8 = new GridBagConstraints();
		gbc_rigidArea_8.insets = new Insets(0, 0, 5, 5);
		gbc_rigidArea_8.gridx = 0;
		gbc_rigidArea_8.gridy = 0;
		results.add(rigidArea_8, gbc_rigidArea_8);
		
		JLabel lblResultsCFind = new JLabel("Here are the results");
		GridBagConstraints gbc_lblResultsCFind = new GridBagConstraints();
		gbc_lblResultsCFind.insets = new Insets(0, 0, 5, 0);
		gbc_lblResultsCFind.anchor = GridBagConstraints.WEST;
		gbc_lblResultsCFind.gridx = 1;
		gbc_lblResultsCFind.gridy = 1;
		results.add(lblResultsCFind, gbc_lblResultsCFind);
		
		Component rigidArea_9 = Box.createRigidArea(new Dimension(20, 20));
		GridBagConstraints gbc_rigidArea_9 = new GridBagConstraints();
		gbc_rigidArea_9.insets = new Insets(0, 0, 5, 0);
		gbc_rigidArea_9.gridx = 1;
		gbc_rigidArea_9.gridy = 2;
		results.add(rigidArea_9, gbc_rigidArea_9);
		
		JButton btnShowResults = new JButton("Show Results");
		GridBagConstraints gbc_btnShowResults = new GridBagConstraints();
		gbc_btnShowResults.anchor = GridBagConstraints.WEST;
		gbc_btnShowResults.gridx = 1;
		gbc_btnShowResults.gridy = 3;
		results.add(btnShowResults, gbc_btnShowResults);
		
		Component rigidArea_10 = Box.createRigidArea(new Dimension(20, 20));
		cFindPanel.add(rigidArea_10, BorderLayout.SOUTH);
		
		JPanel cMovePanel = new JPanel();
		tabbedPane.addTab("C-MOVE", null, cMovePanel, null);
		
		JPanel cStorePanel = new JPanel();
		tabbedPane.addTab("C-STORE", null, cStorePanel, null);
	}

}
